/****************************************************************************************** 
 *	Chili DirectX Framework Version 16.07.20											  *	
 *	Game.cpp																			  *
 *	Copyright 2016 PlanetChili.net <http://www.planetchili.net>							  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "MainWindow.h"
#include "Game.h"

Game::Game( MainWindow& wnd )
	:
	wnd( wnd ),
	gfx( wnd )
{
}

void Game::Go()
{
	gfx.BeginFrame();	
	UpdateModel();
	ComposeFrame();
	gfx.EndFrame();
}

void Game::UpdateModel()
{
	if (wnd.kbd.KeyIsPressed(VK_UP))
	{
		if (inhibitup)
		{
		}
		else
		{
			vy -= 1;
			inhibitup = true;
		}


	}
	else
	{
		inhibitup = false;
	}

	if (wnd.kbd.KeyIsPressed(VK_DOWN))
	{
		if (inhibitdown)
		{
		}
		else
		{
			vy += 1;
			inhibitdown = true;
		}
	}
	else
	{
		inhibitdown = false;
	}
	if (wnd.kbd.KeyIsPressed(VK_LEFT))
	{
		if (inhibitleft)
		{
		}
		else
		{
			vx -= 1;
			inhibitleft = true;
		}

		
	}
	else
	{
		inhibitleft = false;
	}
	if (wnd.kbd.KeyIsPressed(VK_RIGHT))
	{
		if (inhibitright)
		{
		}
		else
		{
			vx += 1;
			inhibitright = true;
		}
		
	}
	else
	{
		inhibitright = false;
	}
	x += vx;
	y += vy;

	if (wnd.kbd.KeyIsPressed(VK_CONTROL))
	{
		r = 0;
	}
	else
	{
		r = 255;

		/*if (x >= 200 && x <= 400)            //colour strip
		{
			r = 0;
		}
		else
		{
			r = 255;
		}*/
	}
	if (ShapeKeyIsPressed)
	{
		if(x+5>=gfx.ScreenWidth)
		{
			x = gfx.ScreenWidth - 6;
			vx = 0;
		}
		if(x-5<0)
		{
			x = 5;
			vx = 0;
		}
		if(y+5>=gfx.ScreenHeight)
		{
			y = gfx.ScreenHeight - 6;
			vy = 0;
			
		}
			
		if (y - 5 < 0)
		{
			y = 5;
			vy = 0;
				
		}
			
		
	}
	else
	{
		

		if (x + 10 >= gfx.ScreenWidth)
		{
			x = gfx.ScreenWidth - 11;
			vx = 0;
		}
		if (x - 10 < 0)
		{
			x = 10;
			vx = 0;
		}
		if (y + 10 >= gfx.ScreenHeight)
		{
			y = gfx.ScreenHeight -11;
			vy = 0;
		}
		if (y - 10<0)
		{
			y = 10;
			vy = 0;
		}
	}
	ShapeKeyIsPressed=(wnd.kbd.KeyIsPressed(VK_SHIFT));
}

void Game::ComposeFrame()
{

	
	if(ShapeKeyIsPressed)
	{
		gfx.PutPixel(-5 + x, y, r, g, b);
		gfx.PutPixel(-4 + x, y, r, g, b);
		gfx.PutPixel(-3 + x, y, r, g, b);
		gfx.PutPixel(-2 + x, y, r, g, b);
		gfx.PutPixel(-1 + x, y, r, g, b);
		gfx.PutPixel(5 + x, y, r, g, b);
		gfx.PutPixel(4 + x, y, r, g, b);
		gfx.PutPixel(3 + x, y, r, g, b);
		gfx.PutPixel(2 + x, y, r, g, b);
		gfx.PutPixel(1 + x, y, r, g, b);
		gfx.PutPixel(x, -5 + y, r, g, b);
		gfx.PutPixel(x, -4 + y, r, g, b);
		gfx.PutPixel(x, -3 + y, r, g, b);
		gfx.PutPixel(x, -2 + y, r, g, b);
		gfx.PutPixel(x, -1 + y, r, g, b);
		gfx.PutPixel(x, 5 + y, r, g, b);
		gfx.PutPixel(x, 4 + y, r, g, b);
		gfx.PutPixel(x, 3 + y, r, g, b);
		gfx.PutPixel(x, 2 + y, r, g, b);
		gfx.PutPixel(x, 1 + y, r, g, b);
	}
	else
	{
		gfx.PutPixel(-10 + x, y, r, g, b);
		gfx.PutPixel(-8 + x, y, r, g, b);
		gfx.PutPixel(-6 + x, y, r, g, b);
		gfx.PutPixel(-4 + x, y, r, g, b);
		gfx.PutPixel(-2 + x, y, r, g, b);
		gfx.PutPixel(10 + x, y, r, g, b);
		gfx.PutPixel(8 + x, y, r, g, b);
		gfx.PutPixel(6 + x, y, r, g, b);
		gfx.PutPixel(4 + x, y, r, g, b);
		gfx.PutPixel(2 + x, y, r, g, b);
		gfx.PutPixel(x, -10 + y, r, g, b);
		gfx.PutPixel(x, -8 + y, r, g, b);
		gfx.PutPixel(x, -6 + y, r, g, b);
		gfx.PutPixel(x, -4 + y, r, g, b);
		gfx.PutPixel(x, -2 + y, r, g, b);
		gfx.PutPixel(x, 10 + y, r, g, b);
		gfx.PutPixel(x, 8 + y, r, g, b);
		gfx.PutPixel(x, 6 + y, r, g, b);
		gfx.PutPixel(x, 4 + y, r, g, b);
		gfx.PutPixel(x, 2 + y, r, g, b);
	}
 }
